<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Constituer
 *
 * @Table(name="constituer")
 * @Entity
 */
class Constituer
{
    /**
     * @var integer $id
     *
     * @Column(name="id", type="integer", nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var float $cstqte
     *
     * @Column(name="cstQte", type="float", nullable=true)
     */
    private $cstqte;

    /**
     * @var Composant
     *
     * @OneToOne(targetEntity="Composant")
     * @JoinColumns({
     *   @JoinColumn(name="cmpCode", referencedColumnName="cmpCode", unique=true)
     * })
     */
    private $cmpcode;

    /**
     * @var Medicament
     *
     * @OneToOne(targetEntity="Medicament")
     * @JoinColumns({
     *   @JoinColumn(name="medDepotlegal", referencedColumnName="medDepotlegal", unique=true)
     * })
     */
    private $meddepotlegal;


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set cstqte
     *
     * @param float $cstqte
     * @return Constituer
     */
    public function setCstqte($cstqte)
    {
        $this->cstqte = $cstqte;
        return $this;
    }

    /**
     * Get cstqte
     *
     * @return float 
     */
    public function getCstqte()
    {
        return $this->cstqte;
    }

    /**
     * Set cmpcode
     *
     * @param Composant $cmpcode
     * @return Constituer
     */
    public function setCmpcode(\Composant $cmpcode = null)
    {
        $this->cmpcode = $cmpcode;
        return $this;
    }

    /**
     * Get cmpcode
     *
     * @return Composant 
     */
    public function getCmpcode()
    {
        return $this->cmpcode;
    }

    /**
     * Set meddepotlegal
     *
     * @param Medicament $meddepotlegal
     * @return Constituer
     */
    public function setMeddepotlegal(\Medicament $meddepotlegal = null)
    {
        $this->meddepotlegal = $meddepotlegal;
        return $this;
    }

    /**
     * Get meddepotlegal
     *
     * @return Medicament 
     */
    public function getMeddepotlegal()
    {
        return $this->meddepotlegal;
    }
}