<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Formuler
 *
 * @Table(name="formuler")
 * @Entity
 */
class Formuler
{
    /**
     * @var integer $id
     *
     * @Column(name="id", type="integer", nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var Medicament
     *
     * @OneToOne(targetEntity="Medicament")
     * @JoinColumns({
     *   @JoinColumn(name="medDepotlegal", referencedColumnName="medDepotlegal", unique=true)
     * })
     */
    private $meddepotlegal;

    /**
     * @var Presentation
     *
     * @OneToOne(targetEntity="Presentation")
     * @JoinColumns({
     *   @JoinColumn(name="preCode", referencedColumnName="preCode", unique=true)
     * })
     */
    private $precode;


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set meddepotlegal
     *
     * @param Medicament $meddepotlegal
     * @return Formuler
     */
    public function setMeddepotlegal(\Medicament $meddepotlegal = null)
    {
        $this->meddepotlegal = $meddepotlegal;
        return $this;
    }

    /**
     * Get meddepotlegal
     *
     * @return Medicament 
     */
    public function getMeddepotlegal()
    {
        return $this->meddepotlegal;
    }

    /**
     * Set precode
     *
     * @param Presentation $precode
     * @return Formuler
     */
    public function setPrecode(\Presentation $precode = null)
    {
        $this->precode = $precode;
        return $this;
    }

    /**
     * Get precode
     *
     * @return Presentation 
     */
    public function getPrecode()
    {
        return $this->precode;
    }
}