<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Interagir
 *
 * @Table(name="interagir")
 * @Entity
 */
class Interagir
{
    /**
     * @var integer $id
     *
     * @Column(name="id", type="integer", nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var Medicament
     *
     * @OneToOne(targetEntity="Medicament")
     * @JoinColumns({
     *   @JoinColumn(name="medDepotlegal", referencedColumnName="medDepotlegal", unique=true)
     * })
     */
    private $meddepotlegal;

    /**
     * @var Medicament
     *
     * @OneToOne(targetEntity="Medicament")
     * @JoinColumns({
     *   @JoinColumn(name="medMeddepotlegal", referencedColumnName="medDepotlegal", unique=true)
     * })
     */
    private $medmeddepotlegal;


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set meddepotlegal
     *
     * @param Medicament $meddepotlegal
     * @return Interagir
     */
    public function setMeddepotlegal(\Medicament $meddepotlegal = null)
    {
        $this->meddepotlegal = $meddepotlegal;
        return $this;
    }

    /**
     * Get meddepotlegal
     *
     * @return Medicament 
     */
    public function getMeddepotlegal()
    {
        return $this->meddepotlegal;
    }

    /**
     * Set medmeddepotlegal
     *
     * @param Medicament $medmeddepotlegal
     * @return Interagir
     */
    public function setMedmeddepotlegal(\Medicament $medmeddepotlegal = null)
    {
        $this->medmeddepotlegal = $medmeddepotlegal;
        return $this;
    }

    /**
     * Get medmeddepotlegal
     *
     * @return Medicament 
     */
    public function getMedmeddepotlegal()
    {
        return $this->medmeddepotlegal;
    }
}