<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Inviter
 *
 * @Table(name="inviter")
 * @Entity
 */
class Inviter
{
    /**
     * @var integer $id
     *
     * @Column(name="id", type="integer", nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var boolean $specialisteon
     *
     * @Column(name="specialisteon", type="boolean", nullable=true)
     */
    private $specialisteon;

    /**
     * @var Activitecompl
     *
     * @OneToOne(targetEntity="Activitecompl")
     * @JoinColumns({
     *   @JoinColumn(name="acNum", referencedColumnName="acNum", unique=true)
     * })
     */
    private $acnum;

    /**
     * @var Praticien
     *
     * @OneToOne(targetEntity="Praticien")
     * @JoinColumns({
     *   @JoinColumn(name="praNum", referencedColumnName="praNum", unique=true)
     * })
     */
    private $pranum;


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set specialisteon
     *
     * @param boolean $specialisteon
     * @return Inviter
     */
    public function setSpecialisteon($specialisteon)
    {
        $this->specialisteon = $specialisteon;
        return $this;
    }

    /**
     * Get specialisteon
     *
     * @return boolean 
     */
    public function getSpecialisteon()
    {
        return $this->specialisteon;
    }

    /**
     * Set acnum
     *
     * @param Activitecompl $acnum
     * @return Inviter
     */
    public function setAcnum(\Activitecompl $acnum = null)
    {
        $this->acnum = $acnum;
        return $this;
    }

    /**
     * Get acnum
     *
     * @return Activitecompl 
     */
    public function getAcnum()
    {
        return $this->acnum;
    }

    /**
     * Set pranum
     *
     * @param Praticien $pranum
     * @return Inviter
     */
    public function setPranum(\Praticien $pranum = null)
    {
        $this->pranum = $pranum;
        return $this;
    }

    /**
     * Get pranum
     *
     * @return Praticien 
     */
    public function getPranum()
    {
        return $this->pranum;
    }
}