<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Medicament
 *
 * @Table(name="medicament")
 * @Entity
 */
class Medicament
{
    /**
     * @var string $meddepotlegal
     *
     * @Column(name="medDepotlegal", type="string", length=10, nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $meddepotlegal;

    /**
     * @var string $mednomcommercial
     *
     * @Column(name="medNomcommercial", type="string", length=25, nullable=true)
     */
    private $mednomcommercial;

    /**
     * @var string $medcomposition
     *
     * @Column(name="medComposition", type="string", length=255, nullable=true)
     */
    private $medcomposition;

    /**
     * @var string $medeffets
     *
     * @Column(name="medEffets", type="string", length=255, nullable=true)
     */
    private $medeffets;

    /**
     * @var string $medcontreindic
     *
     * @Column(name="medContreindic", type="string", length=255, nullable=true)
     */
    private $medcontreindic;

    /**
     * @var float $medprixechantillon
     *
     * @Column(name="medPrixechantillon", type="float", nullable=true)
     */
    private $medprixechantillon;

    /**
     * @var Famille
     *
     * @OneToOne(targetEntity="Famille")
     * @JoinColumns({
     *   @JoinColumn(name="famCode", referencedColumnName="famCode", unique=true)
     * })
     */
    private $famcode;


    /**
     * Get meddepotlegal
     *
     * @return string 
     */
    public function getMeddepotlegal()
    {
        return $this->meddepotlegal;
    }

    /**
     * Set mednomcommercial
     *
     * @param string $mednomcommercial
     * @return Medicament
     */
    public function setMednomcommercial($mednomcommercial)
    {
        $this->mednomcommercial = $mednomcommercial;
        return $this;
    }

    /**
     * Get mednomcommercial
     *
     * @return string 
     */
    public function getMednomcommercial()
    {
        return $this->mednomcommercial;
    }

    /**
     * Set medcomposition
     *
     * @param string $medcomposition
     * @return Medicament
     */
    public function setMedcomposition($medcomposition)
    {
        $this->medcomposition = $medcomposition;
        return $this;
    }

    /**
     * Get medcomposition
     *
     * @return string 
     */
    public function getMedcomposition()
    {
        return $this->medcomposition;
    }

    /**
     * Set medeffets
     *
     * @param string $medeffets
     * @return Medicament
     */
    public function setMedeffets($medeffets)
    {
        $this->medeffets = $medeffets;
        return $this;
    }

    /**
     * Get medeffets
     *
     * @return string 
     */
    public function getMedeffets()
    {
        return $this->medeffets;
    }

    /**
     * Set medcontreindic
     *
     * @param string $medcontreindic
     * @return Medicament
     */
    public function setMedcontreindic($medcontreindic)
    {
        $this->medcontreindic = $medcontreindic;
        return $this;
    }

    /**
     * Get medcontreindic
     *
     * @return string 
     */
    public function getMedcontreindic()
    {
        return $this->medcontreindic;
    }

    /**
     * Set medprixechantillon
     *
     * @param float $medprixechantillon
     * @return Medicament
     */
    public function setMedprixechantillon($medprixechantillon)
    {
        $this->medprixechantillon = $medprixechantillon;
        return $this;
    }

    /**
     * Get medprixechantillon
     *
     * @return float 
     */
    public function getMedprixechantillon()
    {
        return $this->medprixechantillon;
    }

    /**
     * Set famcode
     *
     * @param Famille $famcode
     * @return Medicament
     */
    public function setFamcode(\Famille $famcode = null)
    {
        $this->famcode = $famcode;
        return $this;
    }

    /**
     * Get famcode
     *
     * @return Famille 
     */
    public function getFamcode()
    {
        return $this->famcode;
    }
}