<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Offrir
 *
 * @Table(name="offrir")
 * @Entity
 */
class Offrir
{
    /**
     * @var integer $id
     *
     * @Column(name="id", type="integer", nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var integer $offqte
     *
     * @Column(name="offQte", type="integer", nullable=true)
     */
    private $offqte;

    /**
     * @var Visiteur
     *
     * @OneToOne(targetEntity="Visiteur")
     * @JoinColumns({
     *   @JoinColumn(name="visMatricule", referencedColumnName="visMatricule", unique=true)
     * })
     */
    private $vismatricule;

    /**
     * @var Medicament
     *
     * @OneToOne(targetEntity="Medicament")
     * @JoinColumns({
     *   @JoinColumn(name="medDepotlegal", referencedColumnName="medDepotlegal", unique=true)
     * })
     */
    private $meddepotlegal;

    /**
     * @var Rapportvisite
     *
     * @OneToOne(targetEntity="Rapportvisite")
     * @JoinColumns({
     *   @JoinColumn(name="rapNum", referencedColumnName="rapNum", unique=true)
     * })
     */
    private $rapnum;


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set offqte
     *
     * @param integer $offqte
     * @return Offrir
     */
    public function setOffqte($offqte)
    {
        $this->offqte = $offqte;
        return $this;
    }

    /**
     * Get offqte
     *
     * @return integer 
     */
    public function getOffqte()
    {
        return $this->offqte;
    }

    /**
     * Set vismatricule
     *
     * @param Visiteur $vismatricule
     * @return Offrir
     */
    public function setVismatricule(\Visiteur $vismatricule = null)
    {
        $this->vismatricule = $vismatricule;
        return $this;
    }

    /**
     * Get vismatricule
     *
     * @return Visiteur 
     */
    public function getVismatricule()
    {
        return $this->vismatricule;
    }

    /**
     * Set meddepotlegal
     *
     * @param Medicament $meddepotlegal
     * @return Offrir
     */
    public function setMeddepotlegal(\Medicament $meddepotlegal = null)
    {
        $this->meddepotlegal = $meddepotlegal;
        return $this;
    }

    /**
     * Get meddepotlegal
     *
     * @return Medicament 
     */
    public function getMeddepotlegal()
    {
        return $this->meddepotlegal;
    }

    /**
     * Set rapnum
     *
     * @param Rapportvisite $rapnum
     * @return Offrir
     */
    public function setRapnum(\Rapportvisite $rapnum = null)
    {
        $this->rapnum = $rapnum;
        return $this;
    }

    /**
     * Get rapnum
     *
     * @return Rapportvisite 
     */
    public function getRapnum()
    {
        return $this->rapnum;
    }
}