<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Posseder
 *
 * @Table(name="posseder")
 * @Entity
 */
class Posseder
{
    /**
     * @var integer $id
     *
     * @Column(name="id", type="integer", nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var string $posdiplome
     *
     * @Column(name="posDiplome", type="string", length=10, nullable=true)
     */
    private $posdiplome;

    /**
     * @var float $poscoefprescription
     *
     * @Column(name="posCoefprescription", type="float", nullable=true)
     */
    private $poscoefprescription;

    /**
     * @var Specialite
     *
     * @OneToOne(targetEntity="Specialite")
     * @JoinColumns({
     *   @JoinColumn(name="speCode", referencedColumnName="speCode", unique=true)
     * })
     */
    private $specode;

    /**
     * @var Praticien
     *
     * @OneToOne(targetEntity="Praticien")
     * @JoinColumns({
     *   @JoinColumn(name="praNum", referencedColumnName="praNum", unique=true)
     * })
     */
    private $pranum;


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set posdiplome
     *
     * @param string $posdiplome
     * @return Posseder
     */
    public function setPosdiplome($posdiplome)
    {
        $this->posdiplome = $posdiplome;
        return $this;
    }

    /**
     * Get posdiplome
     *
     * @return string 
     */
    public function getPosdiplome()
    {
        return $this->posdiplome;
    }

    /**
     * Set poscoefprescription
     *
     * @param float $poscoefprescription
     * @return Posseder
     */
    public function setPoscoefprescription($poscoefprescription)
    {
        $this->poscoefprescription = $poscoefprescription;
        return $this;
    }

    /**
     * Get poscoefprescription
     *
     * @return float 
     */
    public function getPoscoefprescription()
    {
        return $this->poscoefprescription;
    }

    /**
     * Set specode
     *
     * @param Specialite $specode
     * @return Posseder
     */
    public function setSpecode(\Specialite $specode = null)
    {
        $this->specode = $specode;
        return $this;
    }

    /**
     * Get specode
     *
     * @return Specialite 
     */
    public function getSpecode()
    {
        return $this->specode;
    }

    /**
     * Set pranum
     *
     * @param Praticien $pranum
     * @return Posseder
     */
    public function setPranum(\Praticien $pranum = null)
    {
        $this->pranum = $pranum;
        return $this;
    }

    /**
     * Get pranum
     *
     * @return Praticien 
     */
    public function getPranum()
    {
        return $this->pranum;
    }
}