<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Praticien
 *
 * @Table(name="praticien")
 * @Entity
 */
class Praticien
{
    /**
     * @var integer $pranum
     *
     * @Column(name="praNum", type="integer", nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $pranum;

    /**
     * @var string $pranom
     *
     * @Column(name="praNom", type="string", length=25, nullable=true)
     */
    private $pranom;

    /**
     * @var string $praprenom
     *
     * @Column(name="praPrenom", type="string", length=30, nullable=true)
     */
    private $praprenom;

    /**
     * @var string $praadresse
     *
     * @Column(name="praAdresse", type="string", length=50, nullable=true)
     */
    private $praadresse;

    /**
     * @var string $pracp
     *
     * @Column(name="praCp", type="string", length=5, nullable=true)
     */
    private $pracp;

    /**
     * @var string $praville
     *
     * @Column(name="praVille", type="string", length=25, nullable=true)
     */
    private $praville;

    /**
     * @var float $pracoefnotoriete
     *
     * @Column(name="praCoefnotoriete", type="float", nullable=true)
     */
    private $pracoefnotoriete;

    /**
     * @var boolean $remplacant
     *
     * @Column(name="remplacant", type="boolean", nullable=false)
     */
    private $remplacant;

    /**
     * @var Typepraticien
     *
     * @OneToOne(targetEntity="Typepraticien")
     * @JoinColumns({
     *   @JoinColumn(name="typCode", referencedColumnName="typCode", unique=true)
     * })
     */
    private $typcode;


    /**
     * Get pranum
     *
     * @return integer 
     */
    public function getPranum()
    {
        return $this->pranum;
    }

    /**
     * Set pranom
     *
     * @param string $pranom
     * @return Praticien
     */
    public function setPranom($pranom)
    {
        $this->pranom = $pranom;
        return $this;
    }

    /**
     * Get pranom
     *
     * @return string 
     */
    public function getPranom()
    {
        return $this->pranom;
    }

    /**
     * Set praprenom
     *
     * @param string $praprenom
     * @return Praticien
     */
    public function setPraprenom($praprenom)
    {
        $this->praprenom = $praprenom;
        return $this;
    }

    /**
     * Get praprenom
     *
     * @return string 
     */
    public function getPraprenom()
    {
        return $this->praprenom;
    }

    /**
     * Set praadresse
     *
     * @param string $praadresse
     * @return Praticien
     */
    public function setPraadresse($praadresse)
    {
        $this->praadresse = $praadresse;
        return $this;
    }

    /**
     * Get praadresse
     *
     * @return string 
     */
    public function getPraadresse()
    {
        return $this->praadresse;
    }

    /**
     * Set pracp
     *
     * @param string $pracp
     * @return Praticien
     */
    public function setPracp($pracp)
    {
        $this->pracp = $pracp;
        return $this;
    }

    /**
     * Get pracp
     *
     * @return string 
     */
    public function getPracp()
    {
        return $this->pracp;
    }

    /**
     * Set praville
     *
     * @param string $praville
     * @return Praticien
     */
    public function setPraville($praville)
    {
        $this->praville = $praville;
        return $this;
    }

    /**
     * Get praville
     *
     * @return string 
     */
    public function getPraville()
    {
        return $this->praville;
    }

    /**
     * Set pracoefnotoriete
     *
     * @param float $pracoefnotoriete
     * @return Praticien
     */
    public function setPracoefnotoriete($pracoefnotoriete)
    {
        $this->pracoefnotoriete = $pracoefnotoriete;
        return $this;
    }

    /**
     * Get pracoefnotoriete
     *
     * @return float 
     */
    public function getPracoefnotoriete()
    {
        return $this->pracoefnotoriete;
    }

    /**
     * Set remplacant
     *
     * @param boolean $remplacant
     * @return Praticien
     */
    public function setRemplacant($remplacant)
    {
        $this->remplacant = $remplacant;
        return $this;
    }

    /**
     * Get remplacant
     *
     * @return boolean 
     */
    public function getRemplacant()
    {
        return $this->remplacant;
    }

    /**
     * Set typcode
     *
     * @param Typepraticien $typcode
     * @return Praticien
     */
    public function setTypcode(\Typepraticien $typcode = null)
    {
        $this->typcode = $typcode;
        return $this;
    }

    /**
     * Get typcode
     *
     * @return Typepraticien 
     */
    public function getTypcode()
    {
        return $this->typcode;
    }
}