<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Prescrire
 *
 * @Table(name="prescrire")
 * @Entity
 */
class Prescrire
{
    /**
     * @var integer $id
     *
     * @Column(name="id", type="integer", nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var string $preposologie
     *
     * @Column(name="prePosologie", type="string", length=40, nullable=true)
     */
    private $preposologie;

    /**
     * @var Medicament
     *
     * @OneToOne(targetEntity="Medicament")
     * @JoinColumns({
     *   @JoinColumn(name="medDepotlegal", referencedColumnName="medDepotlegal", unique=true)
     * })
     */
    private $meddepotlegal;

    /**
     * @var Typeindividu
     *
     * @OneToOne(targetEntity="Typeindividu")
     * @JoinColumns({
     *   @JoinColumn(name="tinCode", referencedColumnName="tinCode", unique=true)
     * })
     */
    private $tincode;

    /**
     * @var Dosage
     *
     * @OneToOne(targetEntity="Dosage")
     * @JoinColumns({
     *   @JoinColumn(name="dosCode", referencedColumnName="dosCode", unique=true)
     * })
     */
    private $doscode;


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set preposologie
     *
     * @param string $preposologie
     * @return Prescrire
     */
    public function setPreposologie($preposologie)
    {
        $this->preposologie = $preposologie;
        return $this;
    }

    /**
     * Get preposologie
     *
     * @return string 
     */
    public function getPreposologie()
    {
        return $this->preposologie;
    }

    /**
     * Set meddepotlegal
     *
     * @param Medicament $meddepotlegal
     * @return Prescrire
     */
    public function setMeddepotlegal(\Medicament $meddepotlegal = null)
    {
        $this->meddepotlegal = $meddepotlegal;
        return $this;
    }

    /**
     * Get meddepotlegal
     *
     * @return Medicament 
     */
    public function getMeddepotlegal()
    {
        return $this->meddepotlegal;
    }

    /**
     * Set tincode
     *
     * @param Typeindividu $tincode
     * @return Prescrire
     */
    public function setTincode(\Typeindividu $tincode = null)
    {
        $this->tincode = $tincode;
        return $this;
    }

    /**
     * Get tincode
     *
     * @return Typeindividu 
     */
    public function getTincode()
    {
        return $this->tincode;
    }

    /**
     * Set doscode
     *
     * @param Dosage $doscode
     * @return Prescrire
     */
    public function setDoscode(\Dosage $doscode = null)
    {
        $this->doscode = $doscode;
        return $this;
    }

    /**
     * Get doscode
     *
     * @return Dosage 
     */
    public function getDoscode()
    {
        return $this->doscode;
    }
}