<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Presentation
 *
 * @Table(name="presentation")
 * @Entity
 */
class Presentation
{
    /**
     * @var integer $id
     *
     * @Column(name="id", type="integer", nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var string $precode
     *
     * @Column(name="preCode", type="string", length=2, nullable=true)
     */
    private $precode;

    /**
     * @var Visiteur
     *
     * @OneToOne(targetEntity="Visiteur")
     * @JoinColumns({
     *   @JoinColumn(name="visMatricule", referencedColumnName="visMatricule", unique=true)
     * })
     */
    private $vismatricule;

    /**
     * @var Medicament
     *
     * @OneToOne(targetEntity="Medicament")
     * @JoinColumns({
     *   @JoinColumn(name="medDepotlegal", referencedColumnName="medDepotlegal", unique=true)
     * })
     */
    private $meddepotlegal;

    /**
     * @var Rapportvisite
     *
     * @OneToOne(targetEntity="Rapportvisite")
     * @JoinColumns({
     * @JoinColumn(name="rapNum", referencedColumnName="rapNum", unique=true)
     * })
     */
    private $rapnum;


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set precode
     *
     * @param string $precode
     * @return Presentation
     */
    public function setPrecode($precode)
    {
        $this->precode = $precode;
        return $this;
    }

    /**
     * Get precode
     *
     * @return string 
     */
    public function getPrecode()
    {
        return $this->precode;
    }

    /**
     * Set vismatricule
     *
     * @param Visiteur $vismatricule
     * @return Presentation
     */
    public function setVismatricule(\Visiteur $vismatricule = null)
    {
        $this->vismatricule = $vismatricule;
        return $this;
    }

    /**
     * Get vismatricule
     *
     * @return Visiteur 
     */
    public function getVismatricule()
    {
        return $this->vismatricule;
    }

    /**
     * Set meddepotlegal
     *
     * @param Medicament $meddepotlegal
     * @return Presentation
     */
    public function setMeddepotlegal(\Medicament $meddepotlegal = null)
    {
        $this->meddepotlegal = $meddepotlegal;
        return $this;
    }

    /**
     * Get meddepotlegal
     *
     * @return Medicament 
     */
    public function getMeddepotlegal()
    {
        return $this->meddepotlegal;
    }

    /**
     * Set rapnum
     *
     * @param Rapportvisite $rapnum
     * @return Presentation
     */
    public function setRapnum(\Rapportvisite $rapnum = null)
    {
        $this->rapnum = $rapnum;
        return $this;
    }

    /**
     * Get rapnum
     *
     * @return Rapportvisite 
     */
    public function getRapnum()
    {
        return $this->rapnum;
    }
}