<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Rapportvisite
 *
 * @Table(name="rapportvisite")
 * @Entity
 */
class Rapportvisite
{
    /**
     * @var integer $rapnum
     *
     * @Column(name="rapNum", type="integer", nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $rapnum;

    /**
     * @var datetime $rapdate
     *
     * @Column(name="rapDate", type="datetime", nullable=true)
     */
    private $rapdate;

    /**
     * @var string $rapbilan
     *
     * @Column(name="rapBilan", type="string", length=255, nullable=true)
     */
    private $rapbilan;

    /**
     * @var string $rapmotif
     *
     * @Column(name="rapMotif", type="string", length=255, nullable=true)
     */
    private $rapmotif;

    /**
     * @var string $rapmotifautre
     *
     * @Column(name="rapMotifAutre", type="string", length=255, nullable=true)
     */
    private $rapmotifautre;

    /**
     * @var boolean $etat
     *
     * @Column(name="etat", type="boolean", nullable=false)
     */
    private $etat;

    /**
     * @var Praticien
     *
     * @OneToOne(targetEntity="Praticien")
     * @JoinColumns({
     *   @JoinColumn(name="praNum", referencedColumnName="praNum", unique=true)
     * })
     */
    private $pranum;

    /**
     * @var Visiteur
     *
     * @OneToOne(targetEntity="Visiteur")
     * @JoinColumns({
     *   @JoinColumn(name="visMatricule", referencedColumnName="visMatricule", unique=true)
     * })
     */
    private $vismatricule;


    /**
     * Get rapnum
     *
     * @return integer 
     */
    public function getRapnum()
    {
        return $this->rapnum;
    }

    /**
     * Set rapdate
     *
     * @param datetime $rapdate
     * @return Rapportvisite
     */
    public function setRapdate($rapdate)
    {
        $this->rapdate = $rapdate;
        return $this;
    }

    /**
     * Get rapdate
     *
     * @return datetime 
     */
    public function getRapdate()
    {
        return $this->rapdate;
    }

    /**
     * Set rapbilan
     *
     * @param string $rapbilan
     * @return Rapportvisite
     */
    public function setRapbilan($rapbilan)
    {
        $this->rapbilan = $rapbilan;
        return $this;
    }

    /**
     * Get rapbilan
     *
     * @return string 
     */
    public function getRapbilan()
    {
        return $this->rapbilan;
    }

    /**
     * Set rapmotif
     *
     * @param string $rapmotif
     * @return Rapportvisite
     */
    public function setRapmotif($rapmotif)
    {
        $this->rapmotif = $rapmotif;
        return $this;
    }

    /**
     * Get rapmotif
     *
     * @return string 
     */
    public function getRapmotif()
    {
        return $this->rapmotif;
    }

    /**
     * Set rapmotifautre
     *
     * @param string $rapmotifautre
     * @return Rapportvisite
     */
    public function setRapmotifautre($rapmotifautre)
    {
        $this->rapmotifautre = $rapmotifautre;
        return $this;
    }

    /**
     * Get rapmotifautre
     *
     * @return string 
     */
    public function getRapmotifautre()
    {
        return $this->rapmotifautre;
    }

    /**
     * Set etat
     *
     * @param boolean $etat
     * @return Rapportvisite
     */
    public function setEtat($etat)
    {
        $this->etat = $etat;
        return $this;
    }

    /**
     * Get etat
     *
     * @return boolean 
     */
    public function getEtat()
    {
        return $this->etat;
    }

    /**
     * Set pranum
     *
     * @param Praticien $pranum
     * @return Rapportvisite
     */
    public function setPranum(\Praticien $pranum = null)
    {
        $this->pranum = $pranum;
        return $this;
    }

    /**
     * Get pranum
     *
     * @return Praticien 
     */
    public function getPranum()
    {
        return $this->pranum;
    }

    /**
     * Set vismatricule
     *
     * @param Visiteur $vismatricule
     * @return Rapportvisite
     */
    public function setVismatricule(\Visiteur $vismatricule = null)
    {
        $this->vismatricule = $vismatricule;
        return $this;
    }

    /**
     * Get vismatricule
     *
     * @return Visiteur 
     */
    public function getVismatricule()
    {
        return $this->vismatricule;
    }
}