<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Realiser
 *
 * @Table(name="realiser")
 * @Entity
 */
class Realiser
{
    /**
     * @var integer $id
     *
     * @Column(name="id", type="integer", nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var float $reamttfrais
     *
     * @Column(name="reaMttfrais", type="float", nullable=true)
     */
    private $reamttfrais;

    /**
     * @var Activitecompl
     *
     * @OneToOne(targetEntity="Activitecompl")
     * @JoinColumns({
     *   @JoinColumn(name="acNum", referencedColumnName="acNum", unique=true)
     * })
     */
    private $acnum;

    /**
     * @var Visiteur
     *
     * @OneToOne(targetEntity="Visiteur")
     * @JoinColumns({
     *   @JoinColumn(name="visMatricule", referencedColumnName="visMatricule", unique=true)
     * })
     */
    private $vismatricule;


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set reamttfrais
     *
     * @param float $reamttfrais
     * @return Realiser
     */
    public function setReamttfrais($reamttfrais)
    {
        $this->reamttfrais = $reamttfrais;
        return $this;
    }

    /**
     * Get reamttfrais
     *
     * @return float 
     */
    public function getReamttfrais()
    {
        return $this->reamttfrais;
    }

    /**
     * Set acnum
     *
     * @param Activitecompl $acnum
     * @return Realiser
     */
    public function setAcnum(\Activitecompl $acnum = null)
    {
        $this->acnum = $acnum;
        return $this;
    }

    /**
     * Get acnum
     *
     * @return Activitecompl 
     */
    public function getAcnum()
    {
        return $this->acnum;
    }

    /**
     * Set vismatricule
     *
     * @param Visiteur $vismatricule
     * @return Realiser
     */
    public function setVismatricule(\Visiteur $vismatricule = null)
    {
        $this->vismatricule = $vismatricule;
        return $this;
    }

    /**
     * Get vismatricule
     *
     * @return Visiteur 
     */
    public function getVismatricule()
    {
        return $this->vismatricule;
    }
}