<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Region
 *
 * @Table(name="region")
 * @Entity
 */
class Region
{
    /**
     * @var string $regcode
     *
     * @Column(name="regCode", type="string", length=2, nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $regcode;

    /**
     * @var string $regnom
     *
     * @Column(name="regNom", type="string", length=50, nullable=true)
     */
    private $regnom;

    /**
     * @var Secteur
     *
     * @OneToOne(targetEntity="Secteur")
     * @JoinColumns({
     *   @JoinColumn(name="secCode", referencedColumnName="secCode", unique=true)
     * })
     */
    private $seccode;


    /**
     * Get regcode
     *
     * @return string 
     */
    public function getRegcode()
    {
        return $this->regcode;
    }

    /**
     * Set regnom
     *
     * @param string $regnom
     * @return Region
     */
    public function setRegnom($regnom)
    {
        $this->regnom = $regnom;
        return $this;
    }

    /**
     * Get regnom
     *
     * @return string 
     */
    public function getRegnom()
    {
        return $this->regnom;
    }

    /**
     * Set seccode
     *
     * @param Secteur $seccode
     * @return Region
     */
    public function setSeccode(\Secteur $seccode = null)
    {
        $this->seccode = $seccode;
        return $this;
    }

    /**
     * Get seccode
     *
     * @return Secteur 
     */
    public function getSeccode()
    {
        return $this->seccode;
    }
}