<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Travailler
 *
 * @Table(name="travailler")
 * @Entity
 */
class Travailler
{
    /**
     * @var integer $id
     *
     * @Column(name="id", type="integer", nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var datetime $jjmmaa
     *
     * @Column(name="jJMMAA", type="datetime", nullable=false)
     */
    private $jjmmaa;

    /**
     * @var string $trarole
     *
     * @Column(name="traRole", type="string", length=11, nullable=true)
     */
    private $trarole;

    /**
     * @var Region
     *
     * @OneToOne(targetEntity="Region")
     * @JoinColumns({
     *   @JoinColumn(name="regCode", referencedColumnName="regCode", unique=true)
     * })
     */
    private $regcode;

    /**
     * @var Visiteur
     *
     * @OneToOne(targetEntity="Visiteur")
     * @JoinColumns({
     *   @JoinColumn(name="visMatricule", referencedColumnName="visMatricule", unique=true)
     * })
     */
    private $vismatricule;


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set jjmmaa
     *
     * @param datetime $jjmmaa
     * @return Travailler
     */
    public function setJjmmaa($jjmmaa)
    {
        $this->jjmmaa = $jjmmaa;
        return $this;
    }

    /**
     * Get jjmmaa
     *
     * @return datetime 
     */
    public function getJjmmaa()
    {
        return $this->jjmmaa;
    }

    /**
     * Set trarole
     *
     * @param string $trarole
     * @return Travailler
     */
    public function setTrarole($trarole)
    {
        $this->trarole = $trarole;
        return $this;
    }

    /**
     * Get trarole
     *
     * @return string 
     */
    public function getTrarole()
    {
        return $this->trarole;
    }

    /**
     * Set regcode
     *
     * @param Region $regcode
     * @return Travailler
     */
    public function setRegcode(\Region $regcode = null)
    {
        $this->regcode = $regcode;
        return $this;
    }

    /**
     * Get regcode
     *
     * @return Region 
     */
    public function getRegcode()
    {
        return $this->regcode;
    }

    /**
     * Set vismatricule
     *
     * @param Visiteur $vismatricule
     * @return Travailler
     */
    public function setVismatricule(\Visiteur $vismatricule = null)
    {
        $this->vismatricule = $vismatricule;
        return $this;
    }

    /**
     * Get vismatricule
     *
     * @return Visiteur 
     */
    public function getVismatricule()
    {
        return $this->vismatricule;
    }
}