<?php



use Doctrine\ORM\Mapping as ORM;

/**
 * Visiteur
 *
 * @Table(name="visiteur")
 * @Entity
 */
class Visiteur
{
    /**
     * @var string $vismatricule
     *
     * @Column(name="visMatricule", type="string", length=10, nullable=false)
     * @Id
     * @GeneratedValue(strategy="IDENTITY")
     */
    private $vismatricule;

    /**
     * @var string $visnom
     *
     * @Column(name="visNom", type="string", length=25, nullable=true)
     */
    private $visnom;

    /**
     * @var string $visprenom
     *
     * @Column(name="visPrenom", type="string", length=50, nullable=true)
     */
    private $visprenom;

    /**
     * @var string $visadresse
     *
     * @Column(name="visAdresse", type="string", length=50, nullable=true)
     */
    private $visadresse;

    /**
     * @var string $viscp
     *
     * @Column(name="visCp", type="string", length=5, nullable=true)
     */
    private $viscp;

    /**
     * @var string $visville
     *
     * @Column(name="visVille", type="string", length=30, nullable=true)
     */
    private $visville;

    /**
     * @var datetime $visdateembauche
     *
     * @Column(name="visDateembauche", type="datetime", nullable=true)
     */
    private $visdateembauche;

    /**
     * @var string $login
     *
     * @Column(name="login", type="string", length=20, nullable=false)
     */
    private $login;

    /**
     * @var string $mdp
     *
     * @Column(name="mdp", type="string", length=20, nullable=false)
     */
    private $mdp;

    /**
     * @var Labo
     *
     * @OneToOne(targetEntity="Labo")
     * @JoinColumns({
     *   @JoinColumn(name="labCode", referencedColumnName="labCode", unique=true)
     * })
     */
    private $labcode;

    /**
     * @var Secteur
     *
     * @OneToOne(targetEntity="Secteur")
     * @JoinColumns({
     *   @JoinColumn(name="secCode", referencedColumnName="secCode", unique=true)
     * })
     */
    private $seccode;


    /**
     * Get vismatricule
     *
     * @return string 
     */
    public function getVismatricule()
    {
        return $this->vismatricule;
    }

    /**
     * Set visnom
     *
     * @param string $visnom
     * @return Visiteur
     */
    public function setVisnom($visnom)
    {
        $this->visnom = $visnom;
        return $this;
    }

    /**
     * Get visnom
     *
     * @return string 
     */
    public function getVisnom()
    {
        return $this->visnom;
    }

    /**
     * Set visprenom
     *
     * @param string $visprenom
     * @return Visiteur
     */
    public function setVisprenom($visprenom)
    {
        $this->visprenom = $visprenom;
        return $this;
    }

    /**
     * Get visprenom
     *
     * @return string 
     */
    public function getVisprenom()
    {
        return $this->visprenom;
    }

    /**
     * Set visadresse
     *
     * @param string $visadresse
     * @return Visiteur
     */
    public function setVisadresse($visadresse)
    {
        $this->visadresse = $visadresse;
        return $this;
    }

    /**
     * Get visadresse
     *
     * @return string 
     */
    public function getVisadresse()
    {
        return $this->visadresse;
    }

    /**
     * Set viscp
     *
     * @param string $viscp
     * @return Visiteur
     */
    public function setViscp($viscp)
    {
        $this->viscp = $viscp;
        return $this;
    }

    /**
     * Get viscp
     *
     * @return string 
     */
    public function getViscp()
    {
        return $this->viscp;
    }

    /**
     * Set visville
     *
     * @param string $visville
     * @return Visiteur
     */
    public function setVisville($visville)
    {
        $this->visville = $visville;
        return $this;
    }

    /**
     * Get visville
     *
     * @return string 
     */
    public function getVisville()
    {
        return $this->visville;
    }

    /**
     * Set visdateembauche
     *
     * @param datetime $visdateembauche
     * @return Visiteur
     */
    public function setVisdateembauche($visdateembauche)
    {
        $this->visdateembauche = $visdateembauche;
        return $this;
    }

    /**
     * Get visdateembauche
     *
     * @return datetime 
     */
    public function getVisdateembauche()
    {
        return $this->visdateembauche;
    }

    /**
     * Set login
     *
     * @param string $login
     * @return Visiteur
     */
    public function setLogin($login)
    {
        $this->login = $login;
        return $this;
    }

    /**
     * Get login
     *
     * @return string 
     */
    public function getLogin()
    {
        return $this->login;
    }

    /**
     * Set mdp
     *
     * @param string $mdp
     * @return Visiteur
     */
    public function setMdp($mdp)
    {
        $this->mdp = $mdp;
        return $this;
    }

    /**
     * Get mdp
     *
     * @return string 
     */
    public function getMdp()
    {
        return $this->mdp;
    }

    /**
     * Set labcode
     *
     * @param Labo $labcode
     * @return Visiteur
     */
    public function setLabcode(\Labo $labcode = null)
    {
        $this->labcode = $labcode;
        return $this;
    }

    /**
     * Get labcode
     *
     * @return Labo 
     */
    public function getLabcode()
    {
        return $this->labcode;
    }

    /**
     * Set seccode
     *
     * @param Secteur $seccode
     * @return Visiteur
     */
    public function setSeccode(\Secteur $seccode = null)
    {
        $this->seccode = $seccode;
        return $this;
    }

    /**
     * Get seccode
     *
     * @return Secteur 
     */
    public function getSeccode()
    {
        return $this->seccode;
    }
}